/*
 * Interface wrapper code.
 *
 * Generated by SIP 4.3.1 (4.3.1-SIP-4_3-362) on Mon Feb 13 15:04:55 2006
 *
 * Copyright (c) 2005
 * 	Riverbank Computing Limited <info@riverbankcomputing.co.uk>
 * 
 * This file is part of PyQt.
 * 
 * This copy of PyQt is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the Free
 * Software Foundation; either version 2, or (at your option) any later
 * version.
 * 
 * PyQt is supplied in the hope that it will be useful, but WITHOUT ANY
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
 * details.
 * 
 * You should have received a copy of the GNU General Public License along with
 * PyQt; see the file LICENSE.  If not, write to the Free Software Foundation,
 * Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#include "sipAPIqt.h"
#include "sipqtQObjectList.h"



static int convertTo_QObjectList(PyObject *sipPy,void **sipCppPtrV,int *sipIsErr)
{
	QObjectList **sipCppPtr = reinterpret_cast<QObjectList **>(sipCppPtrV);

#line 74 "sip/qt/qobjectlist.sip"
	// Convert a Python list of QObject instances to a QObjectList on the
	// heap.

	if (sipIsErr == NULL)
		return PyList_Check(sipPy);

	if (sipPy == Py_None)
	{
		*sipCppPtr = NULL;
		return 0;
	}

	QObjectList *qol = new QObjectList;

	for (int i = 0; i < PyList_GET_SIZE(sipPy); ++i)
	{
		QObject *qobj;

		qobj = reinterpret_cast<QObject *>(sipForceConvertTo_QObject(PyList_GET_ITEM(sipPy,i),sipIsErr));

		if (*sipIsErr)
		{
			delete qol;
			return 0;
		}

		qol -> append(qobj);
	}

	*sipCppPtr = qol;

	return 1;
#line 69 "sipqtQObjectList.cpp"
}


static void *forceConvertTo_QObjectList(PyObject *valobj,int *iserrp)
{
	if (*iserrp || valobj == NULL)
		return NULL;

	if (convertTo_QObjectList(valobj,NULL,NULL))
	{
		void *val;

		/*
		 * Note that we throw away the flag that says if the value
		 * has just been created on the heap or not.
		 */
		convertTo_QObjectList(valobj,&val,iserrp);

		return val;
	}

	sipBadClass(sipNm_qt_QObjectList);

	*iserrp = 1;

	return NULL;
}


static PyObject *convertFrom_QObjectList(void *sipCppV)
{
	QObjectList *sipCpp = reinterpret_cast<QObjectList *>(sipCppV);

#line 42 "sip/qt/qobjectlist.sip"
	PyObject *pl;
	QObject *obj;

	if ((pl = PyList_New(0)) == NULL)
		return NULL;

	// Handle no list.

	if (!sipCpp)
		return pl;

	// Convert the list.

	for (QObjectListIt it(*sipCpp); (obj = it.current()) != NULL; ++it)
	{
		PyObject *inst;

		if ((inst = sipBuildResult(NULL,"M",obj,sipClass_QObject)) == NULL || PyList_Append(pl,inst) < 0)
		{
			Py_XDECREF(inst);
			Py_DECREF(pl);

			return NULL;
		}

		Py_DECREF(inst);
	}

	return pl;
#line 133 "sipqtQObjectList.cpp"
}


sipMappedTypeDef sipMappedType_QObjectList = {
	"QObjectList",
	forceConvertTo_QObjectList,
	convertTo_QObjectList,
	convertFrom_QObjectList
};
